#include "FrustumCullingTraverser.h"
#include "SceneEntity.h"

using namespace std;


namespace CHCDemo
{

FrustumCullingTraverser::FrustumCullingTraverser(): RenderTraverser() 
{
}


void FrustumCullingTraverser::Render()
{
	mRenderState->mTexturesEnabled = false;
	mDistanceQueue.push(mBvh->GetRoot());


	int traversed = 0;
	while (!mDistanceQueue.empty())
	{
		BvhNode *node = mDistanceQueue.top();
		mDistanceQueue.pop();
	
		// interesting for the visualization, so rest and set
		node->SetVisible(false);
		//mNumTraversedNodes ++;

		//bool intersects;
		int intersect;
		if (mBvh->IsWithinViewFrustum(node)!=0)
		{
			// update node's visited flag => needed for rendering
			// so set it also here
			//node->SetLastVisited(mFrameID);
			//node->SetVisible(true);
			++ traversed;
			TraverseNode(node);
			RenderBox(node->GetBox());
		}
		else
		{RenderBox(node->GetBox());
			if (node->IsLeaf()) 
			{
			
			//cout <<"b: " << node->GetBox() << endl;
			}
			//mNumFrustumCulledNodes ++;
		}
		//cout << "intersect: " << intersect << " bx " << node->GetBox() << endl;
	}
		
	//RenderFrustum();

	//std::cout << "traversed: " << traversed << std::endl;
}

}